var tags =
{
	"embed": "src",
	"object": "data"
};

function main()
{
	var expression = "";
	var isFirst = true;
	for(var tag in tags)
	{
		if(isFirst) isFirst = false;
		else expression += " | ";
		expression += ".//" + tag + "[@" + tags[tag] + "]";
	}
	var elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if(elements == null) return;
	for(var i=0; i<elements.snapshotLength; i++) addLink(elements.snapshotItem(i));
}

function addLink(element)
{
	var attribute = tags[element.tagName.toLowerCase()];
	var value = element.getAttribute(attribute);
	var a = document.createElement("a");
	a.setAttribute("href", value);
	var index = value.lastIndexOf("/");
	var name = value.substring(index + 1);
	a.appendChild(document.createTextNode(name));
	var parent = element.parentNode;
	var next = element.nextSibling;
	parent.insertBefore(document.createElement("br"), next);
	parent.insertBefore(a, next); // ADD LINK
	parent.insertBefore(document.createElement("br"), next);
}

main();
